<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
		<xsl:output omit-xml-declaration="yes" method="html" media-type="text/html" encoding="EUC-JP" />
		
		<xsl:template match="/login">
				<html>
				<head>
						<title>コンテンツマネージャー</title>
						<link rel="stylesheet" href="manager.resources/manager.css" type="text/css" />
						<meta http-equiv="Content-Script-Type" content="text/javascript" />
						<script type="text/javascript" src="manager.resources/manager.js" charset="EUC-JP" >//</script>
				</head>
				<body onload="initLoginForm()">
				<div class="main">
						<div align="center">
								<div class="loginwindow" >
										<div><img src="manager.resources/panel_login_top.gif" /></div>
										<div class="loginwindowbody">
												<xsl:if test="errormessage">
														<div class="loginerror"><xsl:value-of select="errormessage/text()" /></div>
												</xsl:if>
												<form action="manager.php" method="post" name="frmLogin" >
														<input type="hidden" name="{/login/reloadtoken/@key}" value="{/login/reloadtoken/@value}" />
														<table border="0">
																<tr><td nowrap="nowrap">ユーザー名：</td><td width="80%"><input type="text" name="param1" value="{@userid}" /></td></tr>
																<tr><td nowrap="nowrap">パスワード：</td><td width="80%"><input type="password" name="param2" value="{@password}" /></td></tr>
														</table>
														<!--
														<input type="checkbox" name="param3" id="param3" /> <label for="param3">ユーザー名をブラウザに保存する。</label><br />
														<input type="checkbox" name="param8" id="param8" /> <label for="param8">ユーザー名をブラウザから削除する。</label><br />
														<input type="checkbox" name="param4" id="param4" onchange="changeUpdateLoginFormVisible( document.frmLogin.param4.checked )" onclick="changeUpdateLoginFormVisible( document.frmLogin.param4.checked )" /> <label for="param4">ユーザー情報を更新する。</label><br />
														<table border="0" id="updatelogin">
																<tr><td>新ユーザー名：</td><td><input type="text" name="param5" /><br /></td></tr>
																<tr><td>新パスワード：</td><td><input type="password" name="param6" /><br /></td></tr>
																<tr><td>新パスワード（再入力）：</td><td><input type="password" name="param7" /><br /></td></tr>
														</table>
														-->
														<br />
														<div class="buttons" align="center">
																<a href="#" class="imagebutton" onclick="document.frmLogin.submit();return false;"><img name="login" value="ログイン" src="manager.resources/button_login.gif" alt="ログイン" /></a>
														</div>
														<input type="hidden" name="login" value="login" />
												</form>
										</div>
										<div><img src="manager.resources/panel_login_bottom.gif" /></div>
								</div>
						</div>
				</div>
				</body>
				</html>
		</xsl:template>

</xsl:stylesheet>