<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	require_once( dirname(__FILE__) . "/xmlconfig.php.inc" );
	
	// Хѿ ------------------------------------------------
	
	// XSLTνϥ󥳡ǥ󥰤̵ˤ뤫
	$gXmlutil_DisableXsltEncoding = false;
	
	function mb_chr($num){
  		return ($num < 256) ? chr($num) : mb_chr($num / 256).chr($num % 256);
	}
	 
	// ƱͤʸɤִeucJP-winбѲѡ
	function utf8_replace_irregular_chars( $str )
	{
		$str = str_replace( mb_chr( 0xefbd9e ), mb_chr( 0xe3809c ), $str );	// ȷʸ U+FF5E  U+301C ִ
		//$str = str_replace( "\xef\xbd\x9e", "\xe3\x80\x9c", $str );
		return $str;
	}	
	
	/* ---------------------------------------------------------------
	 * XSLT饤֥Υåѡ饹
	 */
	class ADDom
	{
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * XSLTѴ¹Ԥ롣
		 * &$xmlDoc : DOM֥ȡ
		 * $filePath : եΥѥ
		 * $outputEncoding : ѤΥ󥳡ǥ󥰡
		 */
		function SaveXmlToFile( &$xmlDoc, $filePath, $outputEncoding = 'UTF-8' )
		{
			$strXml = $xmlDoc->dump_mem( true, $outputEncoding );
			$fp = fopen( $filePath, 'w' );
			set_file_buffer($fp, 0);
			flock( $fp, LOCK_EX );
			rewind($fp);
			
			fwrite( $fp, $strXml );
			
			flock( $fp, LOCK_UN );
			fclose( $fp );
			
			//$xmlDocEntryIndex->dump_file( App::createEntryFilePath( $entryName, 'index' ), false, true );
		}

	}
	
	function ADXslt_error_handler( $handler, $errno, $level, $info )
	{
		$errorMessage = "<h3>CMS Designer : Xsl Translation " . $info['msgtype'] . "</h3>\n" .
						"<dl>\n" .
						"<dt>[message]</dt><dd>" . $info['msg'] . " (code: " . $info['code'] . ")</dd>\n" .
						"<dt>[XSL]</dt><dd>" . $info['URI'] . "</dd>\n" .
						"<dt>[line]</dt><dd>" . $info['line'] . "</dd>\n" .
						"<dt>[module]</dt><dd>" . $info['module'] . "</dd>\n" .
						"</dl>";
		
		cmsd_abort_proc( $errorMessage, false );
	}
	
	function ADXslt_error_handler2( $errno, $errstr )
	{
		$errorMessage = "<h3>CMS Designer : Xsl Translation error" . "</h3>\n" .
						"<dl>\n" .
						"<dt>[message]</dt><dd>" . $errstr . "</dd>\n";
		print( $errorMessage );
	}
	
	/* ---------------------------------------------------------------
	* XSLT饤֥Υåѡ饹
	*/
	class ADXslt
	{
	
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * Xslt饤֥Ԥ
		*/
		
		function setXsltLibNo( $newValue )
		{
			global $gXsltLib;
			$gXsltLib = $newValue;
		}
		
		function getDisableXsltEncoding()
		{
			global $gXmlutil_DisableXsltEncoding;
			return $gXmlutil_DisableXsltEncoding;
		}
		
		function setDisableXsltEncoding( $newValue )
		{
			global $gXmlutil_DisableXsltEncoding;
			$gXmlutil_DisableXsltEncoding = $newValue;
		}
		
	
		function getXsltLibNo()
		{
			global $gXsltLib;
		
			$xsltLib = 10;	// ͤSabloton
		
			if ( $gXsltLib == 0 )
			{
				if ( function_exists( 'xslt_create' ) && function_exists( 'xslt_process' ) && function_exists( 'xslt_free' ) ) 
				{
					$xsltLib = 10;	// Sabloton
				}
				elseif ( function_exists( 'domxml_xslt_stylesheet_file' ) )
				{
					$xsltLib = 20;	// domxml
				}
				else
				{
					$xsltLib = 99;	// ʤ
				}
			}
			else
			{
				$xsltLib = $gXsltLib;
			}
			
			return $xsltLib;
		
		}
	
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * XSLTѴ¹Ԥ롣
		 * &$xmlDoc : ѴоݤDOM֥ȡ
		 * $strXsl : XSLեΥѥ
		 * $outputEncoding : ѤΥ󥳡ǥ󥰡̾XSLT¦ǻꤷΤȤ뤬ĶˤäƤ̵뤵Τľܻꤹ롣
		 * $isXslString : $strXslեѥǤϤʤXSLΤΤξ硣
		*/
		function process( &$xmlDoc, $strXsl, $outputEncoding = 'EUC-JP', $isXslString = false )
		{
			// XSLT-baseǥ쥯ȥ
			if ( ! $isXslString )
			{
				//$basePath = "file://" . dirname( $strXsl ) . '/';
				$basePath = dirname( $strXsl );
			}
			else
			{
				$basePath = '';
			}
		
			// XSLT饤ֹ֥桢XSLTʸѴ
			$xsltLib = ADXslt::getXsltLibNo();
			$disableEncoding = ADXslt::getDisableXsltEncoding();
			
			//print "xsltLib = " . $xsltLib . ", disableXsltEncoding = " . ( $disableEncoding ? "True" : "False" );
			
			// XSLT饤֥ˤʸѴʻꥢξΤߡ
			if ( $disableEncoding )
			{
				set_error_handler( 'ADXslt_error_handler2' );
				
				// XSLǡDOMɤ߹
				if ( $isXslString )
				{
					$xmlDocXsl = @domxml_open_mem( $strXsl );
				}
				else
				{
					$xmlDocXsl = @domxml_open_file( $strXsl );
				}
				
				if ( !$xmlDocXsl )
				{
					print( "<dt>[XSL]</dt><dd>" . convencoding_xml2html( $strXsl ) . "</dd>\n" );
					exit();
				}
				restore_error_handler();
								
				// xsl:output/@encoding롣
				$outputEncodingXsl = '';
				$xpathXsl = $xmlDocXsl->xpath_new_context();
				xpath_register_ns( $xpathXsl, "xsl", "http://www.w3.org/1999/XSL/Transform" );	// ֤̾Ͽ롣
				$xmlXslOutputArr = $xpathXsl->xpath_eval( "//*[self::xsl:output]" );	// xsl:output'//xsl:output'ȡXREAСPHP5.3Ķǥϥ󥰥åפ١ɽѤʤϥ󥰥åפ뤫namespace˴طƤ饤֥ΥХβǽ⤤
				if ( count( cmsd_get_nodeset( $xmlXslOutputArr ) ) > 0 )
				{
					// encoding°¸ߤʤС'UTF-8'˺ؤ롣
					$outputEncodingXsl = $xmlXslOutputArr->nodeset[0]->get_attribute( 'encoding' );
					if ( strlen( $outputEncodingXsl ) > 0 )
					{
						$xmlXslOutputArr->nodeset[0]->set_attribute( 'encoding', 'UTF-8' );	// UTF-8ꤹ롣⤷XSLT饤̵֥꤬뤷Ƥ⡢饤֥εʸɤUTF-8ʤΤʤ
					}
					
					// encoding°¸ߤʤ硢XSLT饤֥ϵUTF-8ǽϤΤʤ
				}
				
				if ( strlen( $outputEncodingXsl ) <= 0 )
				{
					$outputEncodingXsl = 'EUC-JP';	// XSLT¦output encodingꤵƤʤä硢EUC-JPꤵ줿Ȥߤʤ
				}
				
				// XSLǡ򺹤ؤ
				$isXslString = true;
				$strXsl = $xmlDocXsl->dump_mem( true, 'UTF-8' );

			}
			
			
			$resultStr = '';
			
			switch ( $xsltLib )
			{
				case 10:	// Sabloton
					$strXml = $xmlDoc->dump_mem( true, 'UTF-8' );
					$strXml = utf8_replace_irregular_chars( $strXml );	// 2007.10.2 eucJP-winбѡʡֽᥪפηˤ򤹤륳ɡ
					
					$xslt = xslt_create();
					
					xslt_set_error_handler( $xslt, 'ADXslt_error_handler' );
					
					// XSLT-baseǥ쥯ȥŪꤹ롣
					if ( function_exists( 'xslt_set_base' ) and strlen( $basePath ) > 0 )
					{
						xslt_set_base( $xslt, 'file://'.$basePath.'/' );
					}
					
					if ( $isXslString )
					{
						// strXsl:XSLʸξ
						//print( $strXsl );
						$resultStr = @xslt_process( $xslt, 'arg:/_xml', 'arg:/_xsl', NULL, array( '/_xml' => $strXml, '/_xsl' => $strXsl ) );
					}
					else
					{
						// strXsl:եѥξ
						$resultStr = @xslt_process( $xslt, 'arg:/_xml', 'file://'.$strXsl, NULL, array( '/_xml' => $strXml ) );
					}
					
					/*
					// XSLT顼ȯ
					if ( !$resultStr && xslt_errno( $xslt ) > 0 )
					{
						$errorMessage = "XSL Translation Error.<br />\n" .
										"- Message: " . xslt_error( $xslt ) . "<br />\n" .
										"- XSL:  " .
										"<pre>" . convencoding_xml2html( $strXsl ) . "</pre>";
						cmsd_abort_proc( $errorMessage );
					}
					*/
					xslt_free( $xslt );
				
					break;
				
				case 20:	// domxml
				case 21:	// domxml(Ťؿѡ
					set_error_handler( 'ADXslt_error_handler2' );
				
					if ( $isXslString )
					{
						// strXsl:XSLʸξ
						$xslt = domxml_xslt_stylesheet( $strXsl );
					}
					else
					{
						// strXsl:եѥξ
						$xslt = domxml_xslt_stylesheet_file( $strXsl );
					}
					
					if ( !$xslt )
					{
						print( "<dt>[XSL]</dt><dd>" . convencoding_xml2html( $strXsl ) . "</dd>\n" );
						exit();
					}
					
					// XSLT-baseǥ쥯ȥŪꤹ롣
					if ( strlen( $basePath ) > 0 )
					{
						// xslt_set_base ϻȤʤΤǡchdir ǰư롣
						$currdir = getcwd();
						chdir( $basePath );
					}
					
					// 2007.10.2 eucJP-winбѡʡֽᥪפηˤ򤹤륳ɡ
					$strXml = $xmlDoc->dump_mem( true, 'UTF-8' );
					$strXml = utf8_replace_irregular_chars( $strXml );
					$xmlDoc = domxml_open_mem( $strXml );
					
					// XSLT
					$result = $xslt->process( $xmlDoc );
					
					if ( !$result )
					{
						print( "<dt>[XSL]</dt><dd>" . convencoding_xml2html( $strXsl ) . "</dd>\n" );
						exit();
					}
					
					restore_error_handler();
					
					if ( strlen( $basePath ) > 0 )
					{
						// Υǥ쥯ȥ᤹
						chdir( $currdir );
					}
					
					if ( $xsltLib == 20 )
					{
						$resultStr = $xslt->result_dump_mem($result);
					}
					elseif ( $xsltLib == 21 )
					{
						$resultStr = $result->dump_mem();// false );//, $outputEncoding );
						
					}
					
					break;
				
				default:
					cmsd_abort_proc( 'XSLT functions is not supported.' . $xsltLib );
			}
			
			// XSLT饤֥ˤʸѴ硢ʸɤѴ롣
			if ( $disableEncoding )
			{
				if ( strcasecmp( $outputEncodingXsl, 'UTF-8' ) != 0 )
				{
					if ( strcasecmp( $outputEncodingXsl, 'SHIFT_JIS' ) == 0 )
					{
						$outputEncodingXsl = 'SJIS-win'.''; // SJIS-win
					}
					elseif ( strcasecmp( $outputEncodingXsl, 'EUC-JP' ) == 0 )
					{
						$outputEncodingXsl = 'eucJP-win'.''; // eucJP-win
					}
					$resultStr = mb_convert_encoding( $resultStr, $outputEncodingXsl, 'UTF-8' );
				}
			}
			
			// Ǥִ
			// <br/><hr/>ʤɤ<br /><hr />Τ褦Ѵ롣ʺǽ顢xsl:output method="xml"ξˤ褦ȻפäxslȤ򸫤˹ԤȤ礭٤᤿
			$resultStr = preg_replace( '/([^ ])\/>/', '$1 />', $resultStr );
			
			// <div />ȤʤäƤޤäϤ<div></div>Τ褦ˤ롣
			$resultStr = preg_replace( '/<(div|td|th|li|span) \/>/', '<$1></$1>', $resultStr );	// <div /><div ></div>ˤʤʤ褦°ʤΥѴ롣ɽȯǺѤˡä鶵Ƥ
			$resultStr = preg_replace( '/<(div|td|th|li|span) ([^>]*)\/>/', '<$1 $2></$1>', $resultStr );
			
			$resultStr = trim( $resultStr );	// 2006.11.15 ɲáXSLTѴ̤;פʲԤɲä١ŪβԤ
			
			return $resultStr;
			
		}
		
		
		/* -----------------------------------------------------------
		 * [饹᥽å]
		 * XSLTѴ¹Ԥ롣
		 * &$xmlDoc : ѴоݤDOM֥ȡ
		 * $xslFilePath : XSLեΥѥ
		 * $outputEncoding : ѤΥ󥳡ǥ󥰡̾XSLT¦ǻꤷΤȤ뤬ĶˤäƤ̵뤵Τľܻꤹ롣
		*/
		function processStrXsl( &$xmlDoc, $strXsl, $outputEncoding = 'EUC-JP' )
		{
			return ADXslt::process( $xmlDoc, $strXsl, $outputEncoding, true );
			
		}		
		
	}
	
	// disable-xslt-encoding="True" κݤˡXSLT饤֥꤬ưŪxslMETAcharsetUTF-8ˤƤޤΤ򤹤롣
	// ŪˤϡMETAEUC-JP᤹
	function replaceMetaTag( $source, $fromCharset, $toCharset )
	{
		// disable-xslt-encoding="True" κݤˡXSLT饤֥꤬ưŪxslMETAcharsetUTF-8ˤƤޤΤ򤹤롣
		// ŪˤϡMETAEUC-JP᤹
		
		$source = str_replace( array( 'charset='. strtolower( $fromCharset ) . '"', 'charset=' . strtoupper( $fromCharset ) . '"' ), 
									array( 'charset='. strtolower( $toCharset ) . '"', 'charset=' . strtoupper( $toCharset ) . '"' ), 
									$source );
		
		return $source;
	}
	
	
?>