<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */


	/* -----------------------------------------------------------------
	 * γ硦̾Υѥåȥꥵץ󥰤̵ͭ
	 * GD饤֥ΥСˤäƤ"1"ͭˤʤʤ礬ޤ
	 * 0 : ꥵץ󥰤ʤư¿®ʤ
	 * 1 : ꥵץ󥰤ʳ餫ˤʤ
	 */
	$gGDimagecopyfunc = 1;
	
	/* -----------------------------------------------------------------
	 * JPEGγ硦̾βꡣ0100ꤷޤ100ǹǤ
	 *  = 75;
	 */
	$gGDJpegQuality = 75;


	/* -----------------------------------------------------------------
	 *
	 *
	 *
	 */
	class ADImage
	{
		var $image = null;
		var $width = 0;
		var $height = 0;
		
		var $errorMessage = '';
	
		function ADImage()
		{
			// äˤʤ
		}
		
		function loadFromFile( $filepath )
		{
			if ( ! file_exists( $filepath ) )
			{
				$this->errorMessage = $filepath . '¸ߤޤ';
				return null;
			}
			
			// 礭
			$info = getimagesize( $filepath );
			$width = $info[0];
			$height = $info[1];
			
			// 
			switch( $info[2] )
			{
				case IMAGETYPE_GIF: // GIF
					$this->image = imagecreatefromgif( $filepath );
					break;
				
				case IMAGETYPE_JPEG: // JPEG
					$this->image = imagecreatefromjpeg( $filepath );
					break;
				
				case IMAGETYPE_PNG: // PNG
					$this->image = imagecreatefrompng( $filepath );
					break;
				
				default:
					$this->errorMessage = $filepath . 'ϲեǤϤޤ';
					return null;
			}
			
			if ( $width == 0 )
			{
				$width = imagesx( $this->image );
			}
			
			if ( $height == 0 )
			{
				$height = imagesy( $this->image );
			}
			
			$this->width = $width;
			$this->height = $height;
			
			return $this->image;
		
		}
		
		function loadFromResourceID( $image )
		{
			$this->image = $image;
			
			$this->width = imagesx( $image );
			$this->height = imagesy( $image );
		}
		
		function getWidth()
		{
			return $this->width;
		}
		
		function getHeight()
		{
			return $this->height;
		}
		
		function destroy()
		{
			imagedestroy($this->image);
			$this->image = null;
		}
		
		function saveToFile( $filepath, $imageType )
		{
			// ꤷե˽
			global $gGDJpegQuality;
			switch( $imageType )
			{
				case IMAGETYPE_GIF: // GIF
					imagegif( $this->image, $filepath );
					break;
				
				case IMAGETYPE_JPEG: // JPEG
					imagejpeg( $this->image, $filepath, $gGDJpegQuality );
					break;
				
				case IMAGETYPE_PNG: // PNG
					imagepng( $this->image, $filepath );
					break;
			}
		}
		
		
		/* ---------------------------------------------------------------------------
		 * ᡼ΥꥵʽĲ
		 * ꤷ˥ԥåޤ褦˽̾ϳ礹롣
		 * 
		 * return : ADImage
		 */
		function createResizedImage( $width = 0, $height = 0 )
		{
			$widthNew = $this->width;
			$heightNew = $this->height;
		
			// ꤵ줿Ϲ⤵˹碌׻
			/// ⤵Ʊ˻ꤵƤ顢̾Ψ⤤ͤˤͥ褹ΰ˼ޤ褦ˤ
			if ( $width != 0 and $height != 0 )
			{
				//if ( ( $width / $this->width ) >= ( $height / $this->height ) )	// ξդ($this->width * $this->height)򤫤вμƱ̣ˤʤ롣
				if ( ( $width * $this->height ) >= ( $height * $this->width ) )
				{
					$width = 0;
				}
				else
				{
					$height = 0;
				}
			}
			
			/// ̾Υ
			if ( $width != 0 )	// widthꤵƤ
			{
				$widthNew = $width;
				$heightNew = ($width * $this->height) / $this->width;
			}
			else
			{
				$heightNew = $height;
				$widthNew = ($height * $this->width) / $this->height;
			}
			
			// ϲ
			$imageNew = null;
			if ( function_exists( 'imagecreatetruecolor' ) )
			{
				$imageNew = imagecreatetruecolor( $widthNew, $heightNew );
			}
			else
			{
				$imageNew = imagecreate( $widthNew, $heightNew );
			}
			
			// ϲˡ̾
			global $gGDimagecopyfunc;
			if ( $gGDimagecopyfunc === 1 and function_exists( 'imagecopyresampled' ) )
			{
				imagecopyresampled( $imageNew, $this->image, 0, 0, 0, 0, $widthNew, $heightNew, $this->width, $this->height );
			}
			else
			{
				imagecopyresized( $imageNew, $this->image, 0, 0, 0, 0, $widthNew, $heightNew, $this->width, $this->height );
			}
			
			// ADImage
			$adimageNew = new ADImage();
			$adimageNew->loadFromResourceID( $imageNew );
			
			return $adimageNew;
		
		}
	}


?>